## 内网穿透工具使用教程

> 内网穿透，即NAT（Network Address Translation）穿透，网络连接时术语，计算机是局域网内时，外网与内网的计算机节点需要连接通信，有时就会出现不支持内网穿透。就是说映射端口，能让外网的电脑找到处于内网的电脑，提高下载速度。不管是内网穿透还是其他类型的网络穿透，都是网络穿透的统一方法来研究和解决。

简单来说，内网穿透就是一种可以从外网对内网进行访问的手段。

目前市面上有多种内网穿透工具，本文以[NPS](https://ehang-io.github.io/nps/)为例，介绍内网穿透工具的使用。

## NPS

nps是一款轻量级、高性能、功能强大的**内网穿透**代理服务器。目前支持**tcp、udp流量转发**，可支持任何**tcp、udp**上层协议（访问内网网站、本地支付接口调试、ssh访问、远程桌面，内网dns解析等等……），此外还**支持内网http代理、内网socks5代理**、**p2p等**，并带有功能强大的web管理端。

nps分为**服务端**和**客户端**两部分。

### 服务端

在项目[release地址](https://github.com/ehang-io/nps/releases) 下载对应系统版本的server包后解压，然后进入解压后的文件夹

- 执行安装命令

对于linux|darwin `sudo ./nps install`

对于windows，管理员身份运行cmd，进入安装目录 `nps.exe install`

- 启动

对于linux|darwin `sudo nps start`

对于windows，管理员身份运行cmd，进入程序目录 `nps.exe start`

之后访问 [服务器IP]:8080，登录web页面。默认用户名admin，密码123。

下图为[公司域名](https://proxy.elitescloud.com/)下server端管理页面

![image-20200329145134647](./image-20200329145134647.png)

- 新增客户端

点击左侧客户端菜单，然后新增

![image-20200329152337035](./image-20200329152337035.png)

填写备注，其他默认即可

![image-20200329152629653](./image-20200329152629653.png)

添加完成后可在列表中看到刚刚新增的客户端详情以及命令，此时客户端处于offline状态

![image-20200329153007273](./image-20200329153007273.png)


### 客户端

在项目[release地址](https://github.com/ehang-io/nps/releases) 下载对应系统版本的client包后解压，然后进入解压后的文件夹运行刚刚添加的客户端详情中的命令

![image-20200329153645800](./image-20200329153645800.png)

连接成功，此时回到之前的服务端管理页面可以看到新增的客户端状态变为online

![image-20200329153805108](./image-20200329153805108.png)

### 配置客户端连接

#### 访问内网服务

现在服务端和客户端的连接已经建立起来，那么该如何访问内网的服务呢？ 我们回到服务端web页选择进行域名解析操作

![image-20200329155406548](./image-20200329155406548.png)

其中客户端id为你新建的客户端的id，内网目标为你需要访问的内网服务器ip:端口，因为我这边本地在8000端口启动了一个项目，所以这里填的是`localhost:8000`，这里的域名需要在公司服务器下增加对应的域名解析

![image-20200329205509266](./image-20200329205509266.png)

新增完成后，这时我们在浏览器中访问我们刚刚新增的域名解析中的域名发现已经可以访问到我们在本地启动的项目了

![image-20200329210629221](./image-20200329210629221.png)

![image-20200329210650339](./image-20200329210650339.png)

基本的nps使用操作到此结束，此外nps还有诸如tcp隧道，udp隧道等其他功能，具体内容可参考[官方文档](https://ehang-io.github.io/nps/)。